package net.minecraft.command;

import java.util.List;
import java.util.Map;
import net.minecraft.util.math.BlockPos;

public interface ICommandManager
{
    /**
     * Attempt to execute a command. This method should return the number of times that the command was executed. If the
     * command does not exist or if the player does not have permission, 0 will be returned. A number greater than 1 can
     * be returned if a player selector is used.
     */
    int executeCommand(ICommandSender var1, String var2);

    List<String> getTabCompletionOptions(ICommandSender var1, String var2, BlockPos var3);

    List<ICommand> getPossibleCommands(ICommandSender var1);

    Map<String, ICommand> getCommands();
}
